function init_plane(obj)
obj.pitch=0
obj.yaw=0
obj.roll=0
obj.throttle=gEnemyThrottle
obj.rolling=false
obj.watercoll=false
end

function plane_control(obj, x,y,z)
a11,a12,a13,a14,a21,a22,a23,a24,a31,a32,a33,a34,a41,a42,a43,a44=getObjectInfo(obj.cObj, IG3D_ROTATION_MATRIX)
m=getObjectInfo(obj.cObj, IG3D_MASS)
dx,dy,dz=normalized(x-obj.x, y-obj.y, z-obj.z)


obj.yaw=-math.min(dot( a11,a12,a13, dx, dy, dz ),1)*30*passed()
obj.pitch=-math.min(dot( a21, a22, a23, dx, dy, dz),1)*30*passed()
obj.roll=-dot(a11,a12,a13, 0,1,0)*200*passed()

if obj.defend==true then
obj.throttle=math.min(math.max(distance_object_to_point(obj, x,y,z)*2.5, gMinThrottle), gMaxThrottle)
else
obj.throttle=math.min(math.max(distance_object_to_point(obj, x,y,z)*2.5, gMinThrottle), gMaxThrottle)
--obj.throttle=gEnemyThrottle*2
end

if obj.throttle==0 then
obj.throttle=gMinThrottle
end
end


function plane_control2(obj, x,y,z)
a11,a12,a13,a14,a21,a22,a23,a24,a31,a32,a33,a34,a41,a42,a43,a44=getObjectInfo(obj.cObj, IG3D_ROTATION_MATRIX)
m=getObjectInfo(obj.cObj, IG3D_MASS)
dx,dy,dz=normalized(x-obj.x, y-obj.y, z-obj.z)


obj.yaw=-math.min(dot( a11,a12,a13, dx, dy, dz ),1)*30*passed()
obj.pitch=-math.min(dot( a21, a22, a23, dx, dy, dz),1)*30*passed()
obj.roll=-dot(a11,a12,a13, 0,1,0)*200*passed()

d=distance_object_to_point(obj, x,y,z)
d=d*d*0.0005*obj.mothership.throttle
obj.throttle=math.min(math.max(d, obj.mothership.throttle), gMaxThrottle)

--obj.throttle=math.min(math.max(distance_object_to_point(obj, x,y,z)*2.5, gMinThrottle), gMaxThrottle)

end












pi=3.1415

MAX_LIFT_AOA=pi*2
MAX_DRAG_AOA=pi*2
MIN_DRAG_AOA=0.1


function CalculateAirfoilForce(windVelocity, longitudinalAxis, crossSectionAxis, surfaceArea)  
   -- we will asume the both lift and drag forces act at the same aerodimaics center of the airfoild 
    
    
   local veloc2 = dot(windVelocity.x, windVelocity.y, windVelocity.z, windVelocity.x, windVelocity.y, windVelocity.z)
    
   -- we need to determine the airfoild angle of attack 
   -- he is the angle bettewn the relative velocity an the foil crossSectionAxis 
   
   --local windDir={x=windVelocity.x/math.sqrt(veloc2 + 1.0e-2), y=windVelocity.y/math.sqrt(veloc2 + 1.0e-2), z=windVelocity.z/math.sqrt(veloc2 + 1.0e-2)}
   
   windDir={}
   windDir.x, windDir.y, windDir.z=normalized( windVelocity.x, windVelocity.y, windVelocity.z)
   
   
   -- AOA = angle of attack (in radians)
   local AOA = math.acos (dot (windDir.x,windDir.y,windDir.z,  crossSectionAxis.x,crossSectionAxis.y,crossSectionAxis.z))
   
   if AOA > 0.5*pi then
   AOA=AOA-pi
   end
    
   -- we will use a simple clamp function 
   local liftAOA = math.min (MAX_LIFT_AOA, math.max (0, AOA))
   local dragAOA = math.min (MAX_DRAG_AOA, math.max (MIN_DRAG_AOA, AOA))
       
   -- first we need to calculate the fild dynamics presure 
   -- K1 = 0.5 * arerodinamicsPrsesureCosnt * liftCoeficient; 
   -- K2 = 0.5 * arerodinamicsPrsesureCosnt * dragCoeficient;
   local K1=1
   local K2=1
    
   local liftForceMag = K1 * veloc2 * surfaceArea * liftAOA
   local dragForceMag = K2 * veloc2 * surfaceArea * dragAOA
    
   -- now we need to get the lift and drag direction vector  
    
   -- lift is a vector pependiculat teh wind direction, 
   -- care most be taken that the lift vetor point in the correct direction, by 
   -- passing the correct longitudinalAxis value 
   local liftDir={}
 
   
   liftDir.x, liftDir.y, liftDir.z=normalized(cross(windDir.x, windDir.y, windDir.z, longitudinalAxis.x, longitudinalAxis.y, longitudinalAxis.z))
    
    --lift2=dot(liftDir.x, liftDir.y, liftDir.z, liftDir.x, liftDir.y, liftDir.z)
 	--liftDir.x=liftDir.x/(math.sqrt(lift2 + 1.0e-3))
    --liftDir.y=liftDir.y/(math.sqrt(lift2 + 1.0e-3))
    --liftDir.z=liftDir.z/(math.sqrt(lift2 + 1.0e-3))
    
    
    
    --liftDir.x, liftDir.y, liftDir.z=normalized( liftDir.x, liftDir.y, liftDir.z)
    --print(windDir.x, windDir.y, windDir.z)
    --print(liftDir.x, liftDir.y, liftDir.z)
        
   local Force={}
   Force.x=liftDir.x*liftForceMag + windDir.x*dragForceMag
   Force.y=liftDir.y*liftForceMag + windDir.y*dragForceMag
   Force.z=liftDir.z*liftForceMag + windDir.z*dragForceMag
   
   return Force.x,Force.y,Force.z
end

function apply_plane_physics(obj, throttle, pitch, yaw, roll)

a11,a12,a13,a14, a21,a22,a23,a24, a31,a32,a33,a34, a41,a42,a43,a44=getObjectInfo(obj.cObj, IG3D_ROTATION_MATRIX)
b11,b12,b13, b21,b22,b23, b31,b32,b33=mat_inv33(a11,a12,a13, a21,a22,a23, a31,a32,a33)

local dx,dy,dz=getObjectInfo(obj.cObj, IG3D_VELOCITY)


local NetForceG={}
local NetForce={}
local NetTorqueG={}
local NetTorque={x=0, y=0, z=0}
local wind={}
local grav={x=0, y=0, z=0}
local thrust={x=0, y=0, z=0}
local windG={x=-dx, y=-dy, z=-dz}

local h1={x=2, y=0, z=0}
local h2={x=-2, y=0, z=0}
local h3={x=0, y=0, z=-2}

--translate gravity relative to plane
NetForce.x=b11*grav.x+b21*grav.y+b31*grav.z
NetForce.y=b12*grav.x+b22*grav.y+b32*grav.z
NetForce.z=b13*grav.x+b23*grav.y+b33*grav.z

--translate wind relative to plane
wind.x=b11*windG.x+b21*windG.y+b31*windG.z
wind.y=b12*windG.x+b22*windG.y+b32*windG.z
wind.z=b13*windG.x+b23*windG.y+b33*windG.z



--control:

--rudder
h3.x=yaw

--wing airfoils
h1.y=pitch
h2.y=pitch

thrust.z=throttle

NetTorque.z=NetTorque.z+roll


veloc2=dot(wind.x,wind.y,wind.z, wind.x,wind.y,wind.z)




--add thrust
NetForce.x=NetForce.x+thrust.x
NetForce.y=NetForce.y+thrust.y
NetForce.z=NetForce.z+thrust.z

--handle aerodynamic forces

--NetTorque.z= NetTorque.z - dot(a11,a12,a13, 0,1,0)*veloc2*0.025 --roll stabilizer

wind.x=wind.x*0.01
wind.y=wind.y*0.01

wind.x=0
wind.y=0
--wind.z=1


local f={}
local t={}
f.x,f.y,f.z = CalculateAirfoilForce(wind, {x=1, y=0, z=0}, {x=0, y=0, z=1}, 1.0)
t.x,t.y,t.z = cross(f.x, f.y, f.z,   h1.x, h1.y, h1.z)
NetForce.x=NetForce.x+f.x
NetForce.y=NetForce.y+f.y
NetForce.z=NetForce.z+f.z
NetTorque.x=NetTorque.x+t.x
NetTorque.y=NetTorque.y+t.y
NetTorque.z=NetTorque.z+t.z

f.x,f.y,f.z = CalculateAirfoilForce(wind, {x=1, y=0, z=0}, {x=0, y=0, z=1}, 1.0)
t.x,t.y,t.z = cross(f.x, f.y, f.z,   h2.x, h2.y, h2.z)
NetForce.x=NetForce.x+f.x
NetForce.y=NetForce.y+f.y
NetForce.z=NetForce.z+f.z
NetTorque.x=NetTorque.x+t.x
NetTorque.y=NetTorque.y+t.y
NetTorque.z=NetTorque.z+t.z

f.x,f.y,f.z = CalculateAirfoilForce( wind, {x=0, y=1, z=0}, {x=0, y=0, z=1}, 1.0)
t.x,t.y,t.z = cross(f.x, f.y, f.z,   h3.x, h3.y, h3.z)
NetForce.x=NetForce.x+f.x
NetForce.y=NetForce.y+f.y
NetForce.z=NetForce.z+f.z
NetTorque.x=NetTorque.x+t.x
NetTorque.y=NetTorque.y+t.y
NetTorque.z=NetTorque.z+t.z


--translate force to global space
NetForceG.x=a11*NetForce.x+a21*NetForce.y+a31*NetForce.z
NetForceG.y=a12*NetForce.x+a22*NetForce.y+a32*NetForce.z
NetForceG.z=a13*NetForce.x+a23*NetForce.y+a33*NetForce.z

--translate torque to global space
NetTorqueG.x=a11*NetTorque.x+a21*NetTorque.y+a31*NetTorque.z
NetTorqueG.y=a12*NetTorque.x+a22*NetTorque.y+a32*NetTorque.z
NetTorqueG.z=a13*NetTorque.x+a23*NetTorque.y+a33*NetTorque.z

setObjectInfo(obj.cObj, IG3D_FORCE, NetForceG.x, NetForceG.y, NetForceG.z)


dx,dy,dz=getObjectInfo(obj.cObj, IG3D_OMEGA)
setObjectInfo(obj.cObj, IG3D_TORQUE, NetTorqueG.x-dx*0.5, NetTorqueG.y-dy*0.5, NetTorqueG.z-dz*0.5)
----------
end






FORCE_EQUALIZER_COEFFICIENT=0.2
TORQUE_EQUALIZER_COEFFICIENT=0.7
MIN_TORQUE_COMPONENT=-10.0
MAX_TORQUE_COMPONENT=10.0
MAX_TORQUE_MAGNITUDE=3.0
CAMERA_TIGHTNESS=0.3


function apply_plane_physicsnew(obj, thrustx, thrusty, thrustz, pitch, yaw, roll)
a11,a12,a13,a14, a21,a22,a23,a24, a31,a32,a33,a34, a41,a42,a43,a44=getObjectInfo(obj.cObj, IG3D_ROTATION_MATRIX)

dx,dy,dz=getObjectInfo(obj.cObj, IG3D_VELOCITY)

setObjectInfo(obj.cObj, IG3D_FORCE, a11*thrustx+a21*thrusty+a31*thrustz-dx*FORCE_EQUALIZER_COEFFICIENT, a12*thrustx+a22*thrusty+a32*thrustz-dy*FORCE_EQUALIZER_COEFFICIENT +math.min(-800*passed()+vecLength(dx,0,dz), 0), a13*thrustx+a23*thrusty+a33*thrustz-dz*FORCE_EQUALIZER_COEFFICIENT)


local dmag=vecLength(dx,dy,dz)
dmag=math.min(MAX_TORQUE_MAGNITUDE, dmag)
dx,dy,dz=normalized(dx,dy,dz)
dx=dx*dmag
dy=dy*dmag
dz=dz*dmag

pitch=math.max(MIN_TORQUE_COMPONENT, math.min(MAX_TORQUE_COMPONENT, pitch))
yaw=math.max(MIN_TORQUE_COMPONENT, math.min(MAX_TORQUE_COMPONENT, yaw))
roll=math.max(MIN_TORQUE_COMPONENT, math.min(MAX_TORQUE_COMPONENT, roll))

local tpitch={}
tpitch.x=a11*dmag
tpitch.y=a12*dmag
tpitch.z=a13*dmag

local tyaw={}
tyaw.x=-a21*dmag
tyaw.y=-a22*dmag
tyaw.z=-a23*dmag

local troll={}

troll.x=a31*dmag
troll.y=a32*dmag
troll.z=a33*dmag




dx,dy,dz=getObjectInfo(obj.cObj, IG3D_OMEGA)
setObjectInfo(obj.cObj, IG3D_TORQUE, tpitch.x*pitch + tyaw.x*yaw + troll.x*roll -dx*TORQUE_EQUALIZER_COEFFICIENT, tpitch.y*pitch + tyaw.y*yaw + troll.y*roll -dy*TORQUE_EQUALIZER_COEFFICIENT, tpitch.z*pitch + tyaw.z*yaw + troll.z*roll -dz*TORQUE_EQUALIZER_COEFFICIENT)
end
